
import java.awt.Color;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author Erick Rosas
 */
public class MonitorDisplay {

   static private Database fDbConnection;
   static boolean connected = false;
   static JFrame bracket;
 

   public static void main(String args[]) {



      //sets up JFrame
      bracket = new JFrame("Bracket");
      bracket.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      bracket.setSize(1024,780);
      bracket.setVisible(true);
      bracket.setBackground(new Color(0,0,0));
      

      //attempts connetion to the database   
      try {

         fDbConnection = new Database("zrax.net", (short) 3306, "bracket",
            "cs371", "bracket_db");
         fDbConnection.joinEvent("Test Event");
         connected = true;
      } catch (Exception ex) {
         JOptionPane.showMessageDialog(null, "Could not connect to database.", "Error", JOptionPane.ERROR_MESSAGE);
         ex.printStackTrace();
         System.exit(-1);
      }

      //gets initial bracket
      if (connected) {
         try {
            String[][] bracketData = fDbConnection.getBracket();
            if (bracketData == null) {
               JOptionPane.showMessageDialog(null, "No competition data", "Error", JOptionPane.ERROR_MESSAGE);
               return;
            }
            bracket.getContentPane().add(new Window(bracketData, false));
            bracket.pack();

         } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, "Could not Generate Bracket", "Error", JOptionPane.ERROR_MESSAGE);
            ex.printStackTrace();
         }
      }



      //try to refresh the screen about around every minute
      //set to 10 seconds for now to see fast changing database events
      int delay = 5000;
      int period = 1000*10;
      Timer timer = new Timer();

      timer.scheduleAtFixedRate(new TimerTask() {

         public void run() {


            

            if (connected) {
               try {
                 
                  String[][] bracketData = fDbConnection.getBracket();
                  if (bracketData == null) {
                     JOptionPane.showMessageDialog(null, "No competition data", "Error", JOptionPane.ERROR_MESSAGE);
                     return;
                  }
                  
              /*    System.out.println("\n\nNew Bracket:");
                  for(int i=0; i<12; i++){
                     for(int j=0; j<12; j++){
                        System.out.print(bracketData[j][i]+ "  ");
                     }
                     System.out.println();
               }
               */
                  bracket.removeAll();
                  bracket.getContentPane().add(new Window(bracketData, false));
               
                  
                  
               } catch (Exception ex) {
                  JOptionPane.showMessageDialog(null, "Could not Generate Bracket", "Error", JOptionPane.ERROR_MESSAGE);
                  ex.printStackTrace();
               }
            }
         }
      }, delay, period);


   }
}
